import jp.jig.jiglet.*;

public class Dictionary extends Jiglet {
	static final int MODE_INPUT = 0;
	static final int MODE_LIST = 1;
	int mode;
	Image[] img;
	public void main() {
		setSoftLabel("I");
		mode = MODE_INPUT;
		img = new Image[1];
		img[0] = getImage("00.gif");
		readHistory();
		cursor = 0;
		clearKey();
		for (;;) {
			int key = getKey();
			if (mode == MODE_INPUT) {
				if (key == KEY_IAPP || key == KEY_SOFT) {
					return;
				} else if (key == KEY_UP) {
					cursor = (cursor + 3) % 4;
				} else if (key == KEY_DOWN) {
					cursor = (cursor + 1) % 4;
				} else if (key == KEY_LEFT) {
					if (cursor != 0) {
						cursor = (cursor + 1) % 3 + 1;
					}
				} else if (key == KEY_RIGHT) {
					if (cursor == 0) {
						if (history != null && history[0] != null && history[0].length() > 0) {
							mode = MODE_LIST;
							lc = 0;
							lt = 0;
							setSoftLabel("Back");
						}
					} else {
						cursor = cursor % 3 + 1;
					}
				} else if (key == KEY_SELECT && cursor == 0) {
					String s = inputText(word, TEXT_KANA);
					if (s != null && s.length() > 0) {
						word = s;
						cursor = 1;
						for (int i = 0; i < word.length(); i++) {
							char c = word.charAt(i);
							if (!(c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z')) {
								cursor = 2;
								break;
							}
						}
					}
				} else if (key == KEY_SELECT || key >= KEY_1 && key <= KEY_3) {
					if (word != null && word.length() > 0) {
						int c;
						if (key == KEY_SELECT) {
							c = cursor - 1;
						} else {
							c = key - KEY_1;
						}
						addHistory(word);
						String[] suffix = {"&kind=&mode=0&ej.x=10&ej.y=10", "&kind=&mode=0&je.x=10&je.y=10", "&kind=&mode=0&jn.x=10&jn.y=10"};
						launch("http://dictionary.goo.ne.jp/search.php?MT=" + encodeURL(word) + suffix[c], ENCODE_EUC, 1);
						word = null;
						cursor = 0;
					}
				}
			} else if (mode == MODE_LIST) {
				if (key == KEY_SELECT || key == KEY_RIGHT) {
					word = history[lc];
					addHistory(word);
					cursor = 1;
					for (int i = 0; i < word.length(); i++) {
						char c = word.charAt(i);
						if (!(c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z')) {
							cursor = 2;
							break;
						}
					}
					mode = MODE_INPUT;
					setSoftLabel("I");
				} else if (key == KEY_IAPP || key == KEY_LEFT || key == KEY_SOFT) {
					mode = MODE_INPUT;
					setSoftLabel("I");
				} else if (key == KEY_UP || key == KEY_DOWN) {
					if (historyCount >= (ln - 1) && (key == KEY_UP && lc == 0 || key == KEY_DOWN && lc == historyCount - 1)) {
						if (key == KEY_UP) {
							lt = historyCount - ln;
							lc = historyCount - 1;
						} else {
							lt = lc = 0;
						}
					} else {
						if (key == KEY_UP) {
							if (historyCount < ln + 1) {
								lc = (lc + historyCount - 1) % historyCount;
							} else {
								if (lt > 0 && lc == lt + 1) {
									lt--;
								}
								lc--;
							}
						} else {
							if (historyCount < ln + 1) {
								lc = (lc + 1) % historyCount;
							} else {
								if (lt < historyCount - ln && lc == lt + (ln - 2)) {
									lt++;
								}
								lc++;
							}
						}
					}
				}
			}
			repaint();
			sleep(50);
		}
	}
	
	String word;
	int cursor;
	int lc;
	int lt;
	int ln = 10;
	String[] dicName = { "@pa", "Aap", "B" };
	public void paint(boolean allDrawFlag) {
		if (img == null || img[0] == null) {
			return;
		}
		int margin = 5;
		int fh = 12;
		int dw = 150;
		int oh = fh + 5;
		int dh = margin * 3 + oh * 2;
		int sx = (DW - dw) / 2;
		int sy = 20;
		
		setFont(0);
		setColor(255, 255, 255);
		fillRect(0, 0, DW, DH);
		draw3DButton(sx, sy, dw, dh);
		draw3DRect(sx + margin, sy + margin, dw - 2 * margin, oh);
		if (cursor == 0) {
			setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
			fillRect(sx + margin + 1, sy + margin + 1, dw - 2 * margin, oh);
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
		} else {
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
		}
		if (word != null) {
			if (stringWidth(word) > dw - 2 * margin - 4) {
				drawString(word.substring(0, getLineBreak(word, 0, word.length(), dw - 2 * margin - 4)), sx + margin + 2, sy + margin + fh + 2);
			} else {
				drawString(word, sx + margin + 2, sy + margin + fh + 2);
			}
		}
		if (historyCount > 0) {
			drawImage(img[0], sx + dw - margin - 16, sy + margin + 1);
		}
		if (mode == MODE_INPUT) {
			for (int i = 0; i < 3; i++) {
				int w = (dw - margin * 4) / 3;
				int x = sx + margin * (i + 1) + w * i;
				int y = sy + margin * 2 + oh;
				draw3DButton(x, y, w, oh);
				if (cursor == i + 1) {
					setColor(getSystemColor(SYSTEM_COLOR_BUTTON_CURSOR));
					fillRect(x + 2, y + 2, w - 4, oh - 4);
					setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT2));
				} else {
					setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
				}
				drawString(dicName[i], x + (w - stringWidth("@@@")) / 2, y + fh + 2);
			}
		} else if (mode == MODE_LIST) {
			int x = sx + margin;
			int y = sy + margin * 1 + oh;
			int w = dw - margin * 2;
			int h;
			if (historyCount > ln) {
				h = (fh + 4) * ln;
			} else {
				h = (fh + 4) * historyCount;
			}
			setColor(getSystemColor(SYSTEM_COLOR_MENU_BG));
			fillRect(x, y, w, h);
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FRAME1));
			drawLine(x, y, x + w, y);
			drawLine(x, y, x, y + h);
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FRAME2));
			drawLine(x + w, y, x + w, y + h);
			drawLine(x, y + h, x + w, y + h);
			for (int i = 0; i < ln && (lt + i) < historyCount; i++) {
				if (lt + i == lc) {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
					fillRect(x + 1, y + (fh + 4) * i + 1, w - 1, fh + 4);
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
				} else {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
				}
				if (stringWidth(history[lt + i]) > dw - 2 * margin - 4) {
					drawString(history[lt + i].substring(0, getLineBreak(history[lt + i], 0, history[lt + i].length(), dw - 2 * margin - 4)), x + 2, y + (fh + 4) * i + fh + 2);
				} else {
					drawString(history[lt + i], x + 2, y + (fh + 4) * i + fh + 2);
				}
			}
			if (historyCount > ln) {
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BG));
				fillRect(x + w - 3, y + 1, 3, h);
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BAR));
				int sch = h * ln / historyCount;
				int scy;
				if (lt + ln == historyCount) {
					scy = y + h - sch;
				} else {
					scy = y + h * lt / historyCount;
				}
				fillRect(x + w - 3, scy, 3, sch + 1);
			}
		}
	}
	
	int historyCount;
	String[] history = new String[20];
	void readHistory() {
		byte[] b = readSP(0, 1024);
		historyCount = 0xFF & b[0];
		int idx = 1;
		for (int i = 0; i < history.length; i++) {
			if (i < historyCount) {
				int size = 0xFF & b[idx++];
				history[i] = new String(b, idx, size);
				idx += size;
			} else {
				history[i] = null;
			}
		}
	}
	
	void writeHistory() {
		byte[] b = new byte[1024];
		b[0] = (byte)historyCount;
		int idx = 1;
		for (int i = 0; i < historyCount; i++) {
			if (history[i] == null || history[i].length() == 0) {
				b[idx++] = 0;
			} else {
				byte[] b2 = history[i].getBytes();
				b[idx++] = (byte)(0xFF & b2.length);
				arraycopy(b2, 0, b, idx, b2.length);
				idx += b2.length;
			}
		}
		writeSP(0, b);
	}
	
	void addHistory(String s) {
		for (int i = 0; i < history.length; i++) {
			if (history[i] != null && history[i].equals(s)) {
				if (i == 0) {
					return;
				}
				String[] ss = new String[history.length];
				arraycopy(history, 0, ss, 1, i);
				arraycopy(history, i + 1, ss, i + 1, history.length - i - 1);
				ss[0] = s;
				history = ss;
				writeHistory();
				return;
			}
		}
		String[] ss = new String[history.length];
		arraycopy(history, 0, ss, 1, history.length - 1);
		ss[0] = s;
		history = ss;
		historyCount++;
		if (historyCount > history.length) {
			historyCount = history.length;
		}
		writeHistory();
	}
}
